*------------------------------------------------------------*
*Program: TNDS Workshop: SAS Program
*Programmer: Emily Sanchez emily.sanchez@tufts.edu
*Date: 19 January 2021
*Purpose: The Basics
*Last edited: 23 Februray 2021
*-------------------------------------------------------------*

*-------Program Orientation-------*
*Five windows: 1) Explorer
			   2) Results
			   3) Program Editor
			   4) Log
			   5) Output/Results Viewer

*-------The Basics-------*
*The SAS program is a sequence of statements executed in order.  
Each statement ends in a semicolon.
Statements can be in lower or uppercase, and can be on the same line as other statement*
Color-coded syntax: key words (DATA, CLASS, MODEL) are highlighted in blue
					quotations are highlighted in purple/red
					variable/data set names are highlighted in black
					formats with '.' are highlighed in teal
					comments are highlighed in green

*-------The SAS Data Set-------*
Variables (columns)
Observations (rows)
Data Types: Numeric and Character
Missing Data: Numeric is a '.'
			  Character is blank

*-------Rules for Data Set and Variable Naming-------*
Must be 32 characters or less
Must start with a letter or an underscore (_)
Names can only contain letters, numbers and (_)
Not case sensitive

*-------Comment Blocks-------*
Start with (*) and end with semicolon, OR
with /* text */

*-------Getting Started-------*
First, establish your libraries or LIBNAME.  This is where are you physically going to read/write permanent SAS data
A LIBNAME statement can go anywhere in the program but is typically at the beginning.

Syntax:
LIBNAME library name engine 'location' <- default engine, so will no longer include going forward

Example:; 
LIBNAME IN1 'C:\Users\esanch09\Desktop\data for workshop'; **Where you are pulling your data set from;
LIBNAME OUT1 'C:\Users\esanch09\Desktop\data for workshop'; **Where you you want to write your final data set, does not have to be separate


All SAS data sets have a 2 level name, i.e. libraryreferece.dataset
The library reference referes to the LIBNAME while the dataset referes to the SAS data set name.;

/*Example:
LIBNAME IN1 'name'; <-- library name
	DATA IN1.TEMP;			
	SET TEST; <--- data set name
RUN;
*/

/*If you see a one level name such as TEMP below the library reference is assumed to be the WORK libary.
The WORK library exists only during your active SAS session and once SAS is closed, everything in it is DELETED!

Example:
	DATA TEMP;
	SET TEST;
RUN;
				IS EQUAL TO

	DATA WORK.TEMP;
	SET TEST;
RUN;
	
*/
/*

*DATA vs PROCedure Steps*
DATA Steps:								PROC Steps:
- Begin with DATA statment				- Begin with PROC statement
- Create SAS data sets					- Perfom an analysis or function
- Ends with RUN; statement, or			- Produce a result or output
	New Data/PROC invocation			- Ends with RUN; (and QUIT;) statement, or
											New DATA/PROC invocation

Putting it all together

LIBNAME IN1 'name';  		:::LIBNAME:::

	DATA TEMP;					:::DATA STEP:::
	SET IN1.TEST;
RUN;

PROC CONTENTS DATA=TEMP; RUN; 	:::PROC STEP:::

*-------Process Flow-------*
1. Compile or descriptor phase
	- SAS determines the attributes of the variables and creates an input buffer where
		it will place each line of data that will eventually be read.
	- SAS checks syntax(not logic)and the code is read sequentially from top to bottom.
2. Execution phase
	- SAS sets all the variables in the input buffer to missing and then reads in data line
		by line (observation by observation)

/*-------Opening Existing SAS Data-------*

DATA TEMP;
SET IN1.TEST; <--- This creates a temporary data set from a permanent one, i.e. IN1 is the library reference and TEST is the dataset name;
RUN;

*-------Saving Existing SAS Data-------*
DATA IN1.PERM; <--- This creates a permanent data set from a temporary one, i.e. OUT is the library reference and PERM is the dataset name;
SET TEMP; 
RUN;
